function c = jcov(X)
% cov   covariance value.
% (Quaternion overloading of standard Matlab function.)

% Copyright  2010 Clive Cheong Took
% See the file : Copyright.m for further details.

% error(nargchk(1, 2, nargin)), error(nargoutchk(0, 1, nargout)) 
% 

[m,n]=size(X); 

%Ensure we have  a matrix of size => no_signals x no_samples
if m>n
    X=transpose(X);
    [m,n]=size(X); 
end

%Calculate the average (avg) or mean
avg = class(compose(mean(ess(X), 2), ...
                    mean(exe(X), 2), ...
                    mean(wye(X), 2), ...
                    mean(zed(X), 2)), 'quaternion');

%Remove the mean
X=X-repmat1(avg,1,n);

c=mtimes(X, jhermitian(X))/n; % (xx^H)/n
















%times(u,conj(e(n)))