function d = triu(v, k)
% TRIU Extract upper triangular part.
% (Quaternion overloading of standard Matlab function.)

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 2, nargin)), error(nargoutchk(0, 1, nargout)) 

if nargin == 1
    if ispure_internal(v)
        d = class(compose(triu(exe(v)), ...
                          triu(wye(v)), ...
                          triu(zed(v))), 'quaternion');
    else
        d = class(compose(triu(ess(v)), ...
                          triu(exe(v)), ...
                          triu(wye(v)), ...
                          triu(zed(v))), 'quaternion');
    end
else
    if ispure_internal(v)
        d = class(compose(triu(exe(v), k), ...
                          triu(wye(v), k), ...
                          triu(zed(v), k)), 'quaternion');
    else
        d = class(compose(triu(ess(v), k), ...
                          triu(exe(v), k), ...
                          triu(wye(v), k), ...
                          triu(zed(v), k)), 'quaternion');
    end
end
