function d = tril(v, k)
% TRIL Extract lower triangular part.
% (Quaternion overloading of standard Matlab function.)

% Copyright  2005 Stephen J. Sangwine and Nicolas Le Bihan.
% See the file : Copyright.m for further details.

error(nargchk(1, 2, nargin)), error(nargoutchk(0, 1, nargout))

if nargin == 1
    if ispure_internal(v)
        d = class(compose(tril(exe(v)), ...
                          tril(wye(v)), ...
                          tril(zed(v))), 'quaternion');
    else
        d = class(compose(tril(ess(v)), ...
                          tril(exe(v)), ...
                          tril(wye(v)), ...
                          tril(zed(v))), 'quaternion');
    end
else
    if ispure_internal(v)
        d = class(compose(tril(exe(v), k), ...
                          tril(wye(v), k), ...
                          tril(zed(v), k)), 'quaternion');
    else
        d = class(compose(tril(ess(v), k), ...
                          tril(exe(v), k), ...
                          tril(wye(v), k), ...
                          tril(zed(v), k)), 'quaternion');
    end
end
